# Copyright (C) 1999, 2000
# by Juergen Pfeifer <juergen@gnuada.org>
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
# Author: Juergen Pfeifer <juergen@gnuada.org>
# ---------------------------------------------------------------------------
# GNU Ada RPM Packaging for the GNU Ada Checker (gch)
#
# This specification file is generated using a m4 based macrosystem.
# Please don't change it directly but get instead the macro system
# and change the input files of this system. 
# ---------------------------------------------------------------------------
#
%define        PKG_TARGET_OS       Linux
%define        TARGET_OS           linux
%define        TARGET_ARCH         i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        DEF_USER            bin
%define        DEF_GROUP           bin
%define        CFG_PREFIX          /usr
#
%define        AUTHOR_NAME         Juergen Pfeifer
%define        AUTHOR_MAIL	   juergen.pfeifer@gmx.net
#
%define        GNAT_BASE_VERSION   3.12
%define        GNAT_PKG_VERSION    3.12p
%define        GNAT_PKG_RELEASE    11
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
%define        GLIBC_VERSION	   2.1
%define        GNAT_VERSION        3.12p
%define        BASE_VERSION        gcc-%{GCC_VERSION}
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat
%define        GNATRT_PKG_NAME     gnat-3.12p-runtime
%define        GNATRT_PKG_VERSION  1
#
%define        ADA_ROOT            /lib/ada
%define        ADA_BASE            %{CFG_PREFIX}%{ADA_ROOT}
%define        SHARE_BASE	   /share/ada
%define        ADA_SHARE           %{CFG_PREFIX}%{SHARE_BASE}
#
%define        HTML_BASE	   %{SHARE_BASE}/html
%define        ADA_HTML	           %{CFG_PREFIX}%{HTML_BASE}
#
%define        GNAT_SO_MAJOR       1
%define        GNAT_SO_MINOR       %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS         -O3 -m486
%define        RPM_ADA_FLAGS       -gnatpn
#
%define        THREADLIBS          -lpthread
#
%define        DOC_BASE            %{CFG_PREFIX}/doc
#
%define        GNAT_ALIAS          %{BASE_NAME}
%define        GNAT_NAME           %{GNAT_ALIAS}-%{GNAT_VERSION}
%define        GNAT_SO             %{GNAT_NAME}
#
%define        GNARL_ALIAS         gnarl
%define        GNARL_NAME          %{GNARL_ALIAS}-%{GNAT_VERSION}
%define        GNARL_SO            %{GNARL_NAME}
#
%define        AINC_NAME           adainclude
%define        AINC_DIR            %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME           adalib
%define        ALIB_DIR            %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME            etc
%define        ETC_DIR             %{ADA_BASE}/%{ETC_NAME}
%define        EMACS_DIR           %{ADA_ROOT}/%{ETC_NAME}/adamode
%define        ADAMODE_DIR         %{CFG_PREFIX}%{EMACS_DIR}
%define        INFO_NAME           %{ADA_ROOT}/info
%define        INFO_DIR            %{CFG_PREFIX}%{INFO_NAME}
#
%define        ASIS_ALIAS          asis
%define        ASIS_NAME           %{ASIS_ALIAS}-%{GNAT_VERSION}
%define        ASIS_SO             %{ASIS_NAME}
%define        ASIS_DIR            %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_ALIAS         garlic
%define        GLADE_NAME          garlic-%{GNAT_VERSION}
%define        GLADE_SO            garlic-%{GNAT_VERSION}
%define        GLADE_DIR           %{ADA_BASE}/%{GLADE_NAME}
#
%define        FLORIST_ALIAS       florist
%define        FLORIST_NAME        %{FLORIST_ALIAS}-%{GNAT_VERSION}
%define        FLORIST_SO          %{FLORIST_NAME}
#
%define        GNAT_GCC            gnatgcc
#
%define PKG_NAME    gch
%define PKG_VERSION 19990519
%define PKG_RELEASE 1mdk
# 
# If there is a runtime package, it has this name
%define PKGRT_NAME  gch-runtime
#
# Name of development package in the old scheme
%define OLD_DEVPKG_NAME gch-devel-3.12p
%define OLD_RTNAME      gch-3.12p
#
# ---------------------------------------------------------------------------
# We restrict the use of this package script at the moment to Intel and
# Linux. For sure there are details (compiler options, shared library
# building) that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{PKG_TARGET_OS}
#Vendor:        Ada for Linux Team (ALT)
Packager:      Juergen Pfeifer
#Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{name}-buildroot
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
#
# This are the official sources
Source0:       %{name}.tar.bz2
#
# This is our patch
Patch0:        gch.diff.bz2
#
#  ---------------------------------------------------------------------------
Copyright:     GPL
URL:           http://www.kolumbus.fi/vitali.kaufman/gch/
Summary:       Ada Rule Checker
Group:         Development/Other
Buildrequires: gnat gnat-3.12p-runtime asis
Requires:      %{GNAT_PKG_NAME} = %{GNAT_PKG_VERSION}
Requires:      %{GNATRT_PKG_NAME} = %{GNATRT_PKG_VERSION}
Obsoletes:     %{name}
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description
gch (from Gnat CHecker) is a tool that checks Ada sources against a given set
of rules. In the current version of gch checks for some rules from the
Ada 95 Quality and Style document.

gch is an ASIS-based tool built on top of the ASIS implementation for
GNAT (ASIS-for-GNAT).
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q
%patch0 -p0
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
#
# Get the name of the Operating System in lower case
OS=%{TARGET_OS}
#
PATH=/usr/bin:/bin:/sbin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin:/usr/local/sbin
if [ "${GNAT_ROOT}" != "" ]; then
   PATH="${GNAT_ROOT}/bin:${PATH}"
fi
export PATH
#
%define ALT_BUILD_DOC  $RPM_BUILD_ROOT/doc
%define ALT_BUILD_HTML $RPM_BUILD_ROOT%{ADA_HTML}
#
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/info
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/lib
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/doc
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT%{GLADE_DIR}
mkdir -p $RPM_BUILD_ROOT%{ASIS_DIR}
mkdir -p $RPM_BUILD_ROOT%{ETC_DIR}
mkdir -p $RPM_BUILD_ROOT%{INFO_DIR}
mkdir -p $RPM_BUILD_ROOT%{ADA_SHARE}
mkdir -p %{ALT_BUILD_DOC}
mkdir -p %{ALT_BUILD_HTML}
#
#
cp -pdf Readme.txt %{ALT_BUILD_DOC}
cd gch
gnatmake -o gch %{RPM_C_FLAGS} %{RPM_ADA_FLAGS} \
   -I${GNAT_ROOT:-/usr}/lib/asis gch-driver.adb -largs -lasis
strip gch
cd ..
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
cd gch
cp -pdf gch   $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
cp -pdf *.ini $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
chmod 0644 $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/*.ini
cp -pdrf Tests %{ALT_BUILD_DOC}
cd ..
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.o'   -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
#  ---------------------------------------------------------------------------
%pre
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${GNAT_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${GNAT_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
#  ---------------------------------------------------------------------------
%preun
#  ---------------------------------------------------------------------------
%postun
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc %{ALT_BUILD_DOC}/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/doc
%{CFG_PREFIX}/bin/gch
%{CFG_PREFIX}/bin/*.ini
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------

#
%changelog
* Mon May 08 2000 Lenny Cartier <lenny@mandrakesoft.com> 19990519-1mdk
- bzip patch and sources
- fix group
- used srpm provided by Juergen Pfeifer <juergen@gnuada.org>

* Thu Apr 27 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as release 4

* Wed Apr 26 2000 Juergen Pfeifer <juergen@gnuada.org>
- Use computed GNAT_INSTALL_PREFIX instead of RPM_INSTALL_... to support
  SuSE YaST based installations.

* Sun Feb 27 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as Release 3

* Wed Feb 23 2000 Juergen Pfeifer <juergen@gnuada.org>
- Grand package renaming

* Mon Jan 17 2000 Juergen Pfeifer <juergen@gnuada.org>
- Fixed bug that caused ini files not to be found. Problem reported and
  solution proposed by Wilhelm Spickermann.
- Published as Release 2

* Sat Nov 27 1999 Juergen Pfeifer <juergen@gnuada.org>
- Created and published as Release 1
